routes/web.php
<?php

use App\Http\Controllers\AdminpanelController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ContentController;
use App\Http\Controllers\DocumentController;
use App\Http\Controllers\TrainingController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\UserviewController;
use Illuminate\Support\Facades\Route;

Route::get('/', [UserviewController::class,'index']);

Route::get('/home', [UserviewController::class,'home']);
Route::get('/all-contents', [UserviewController::class,'allContents']);
Route::get('/content-documents/{content}', [UserviewController::class,'contentDocuments']);


Route::get('/documents-lists', [UserviewController::class,'documentsLists']);
Route::get('/trainings-lists', [UserviewController::class,'trainingsLists']);
Route::get('/trainings-details/{training}', [UserviewController::class,'trainingsDetails']);

// Route::get('/details', function () {
//     $directory = __DIR__ .'/../public/storage/media';

//     $files = File::directories($directory);
//     dd($files);
//     return view('userview.details', [
//         'files' => $files,
//     ]);
// });

Route::prefix('admin')->group(function () {
    Route::get('/dashboard', [AdminpanelController::class,'dashboard']);
    Route::resource('/contents', ContentController::class);
    Route::resource('/trainings', TrainingController::class);
    Route::get('/courses/create/sub-folder', [TrainingController::class,'createSubFolder']);
    Route::get('/train/choosetitle', [TrainingController::class,'choosetitle'])->name('choosetitle');
    Route::resource('/users', UserController::class);
    Route::resource('/documents', DocumentController::class);
});


Route::get('/checkSlugDoc', [DocumentController::class,'checkSlugDoc'])->name('checkSlugDoc');
Route::get('/checkSlugTraining', [TrainingController::class,'checkSlugTraining'])->name('checkSlugTraining');

app/Models/Document.php
<?php

namespace App\Models;

use \Cviebrock\EloquentSluggable\Sluggable;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Document extends Model
{
    use HasFactory ,Sluggable;


    protected $guarded = [];
    /**
       * Return the sluggable configuration array for this model.
       *
       * @return array
       */
    public function sluggable(): array
    {
        return [
            'slug' => [
                'source' => 'title'
            ]
        ];
    }
    public function content()
    {
        return $this->belongsTo(Content::class);
    }
}

app/Http/Controllers/DocumentController.php
<?php

namespace App\Http\Controllers;

use App\Models\Content;
use App\Models\Document;
use Illuminate\Http\Request;
use \Cviebrock\EloquentSluggable\Services\SlugService;

class DocumentController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        return view('adminview.documents.show', [
            'documents' =>Document::all(),
        ]);
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('adminview.documents.upload', [
            'contents' => Content::all(),
        ]);

    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        // return $request;
        Document::create([
          'title' => $request->title,
          'description' => $request->description,
          'slug' => $request->slug,
          'content_id' => $request->content_id,
          'link' => $request->link,
          'uploaded_by'=>'thaenandarsoe',
        ]);
        return redirect()->route('documents.index');

    }

    /**
     * Display the specified resource.
     */
    public function show(Document $document)
    {
        return view('adminview.documents.details', [
          'document' => $document,
      ]);

    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Document $document)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Document $document)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Document $document)
    {
        //
    }
    public function checkSlugDoc(Request $request)
    {

        $slug = SlugService::createSlug(Document::class, 'slug', $request->title);
        return response()->json(['slug'=>$slug]);
    }
}

resources/views/adminview/documents/details.blade.php
@extends('components.backend.layout')
@section('content')
<x-backend.header />
<x-backend.sidebar />

<main id="main" class="main">

    <x-backend.pagetitle title="Document Details" />

    <section class="section">
        <div class="container result-container">
            <div class="row">
                <div class="card my-4 p-4">

                    <div class="col-md-12 service-box text-start " data-aos="fade-up" data-aos-delay="200">
                        {{-- <i class="ri-discuss-line icon"></i> --}}

                        <p class="detail-para"> <strong>ID -</strong> {{$document->id}}</p>

                        <p class="detail-para"> <strong>Title -</strong> {{$document->title}}</p>

                        <p class="detail-para"> <strong>Slug -</strong> {{$document->slug}} </p>

                        <p class="detail-para"> <strong>Description -</strong> {{$document->description}} </p>

                        <p class="detail-para"> <strong>Category -</strong> {{$document->content->name}} </p>

                        <p class="detail-para"> <strong>Uploaded by -</strong> {{$document->uploaded_by}} </p>

                        <p class="detail-para"> <strong>Created at -</strong> {{$document->created_at->format('d-M-Y
                            H:m:s')}} </p>

                        <p class="detail-para"> <strong>Latest Edited at -</strong>
                            {{$document->updated_at->format('d-M-Y H:m:s')}} </p>

                        <p class="detail-para"> <strong>Link -</strong> <a href="{{$document->link}}"
                                target="_blank">{{$document->link}}</a>
                        </p>

                    </div>

                    <div class="col-md-4">

                        <a href="{{route('documents.index')}}"><button type="submit" class="btn btn-success "> <i
                                    class="bi bi-list-ul"></i></button></a>

                        <button type="submit" class="btn btn-primary "> <i class="bi bi-pencil"></i></button>

                        <button type="submit" class="btn btn-danger"> <i class="bi bi-trash"></i></button>

                    </div>
                </div>
            </div>
        </div>
    </section>



</main><!-- End #main -->
@endsection

resources/views/adminview/documents/show.blade.php
@extends('components.backend.layout')
@section('content')
<x-backend.header />
<x-backend.sidebar />

<main id="main" class="main">

    <x-backend.pagetitle title="Documents" />

    <section class="section">
        <div class="row">
            <div class="col-lg-12">

                <div class="card">
                    <div class="card-body py-5">

                        <button class="btn btn-sm  shadow-none"><input type="checkbox" name="" id=""></button>
                        <button class="btn btn-sm btn-info shadow-none"> <i class="bi bi-check2-square"></i> 0
                            selected</button>
                        <button class="btn btn-sm btn-danger shadow-none"> <i class="bi bi-trash"></i> Bulk
                            Delete</button>

                        <div class="table-responsive">
                            <!-- Table with stripped rows -->
                            <table class="table datatable">
                                <thead>
                                    <tr>
                                        <th scope="col">#</th>
                                        <th scope="col">Title</th>
                                        <th scope="col">Content</th>
                                        <th scope="col">Description</th>
                                        <th scope="col">Date Create</th>
                                        <th scope="col">Actions</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach ($documents as $document)
                                    <tr>
                                        <th scope="row">{{$document->id}}</th>
                                        <td> <a href="{{$document->link}}" target="_blank">{{$document->title}}</a>
                                        </td>
                                        <td>{{$document->content->name}}</td>
                                        <td>{{$document->description}}</td>

                                        <td>{{$document->created_at}}</td>
                                        <td>
                                            <span class="btn btn-sm btn-success mb-3"><i
                                                    class="bi bi-pencil-square"></i>
                                            </span>
                                            <a href="{{route('documents.show',$document->id)}}"><span
                                                    class="btn btn-sm btn-warning mb-3"><i
                                                        class="bi bi-eye"></i></span></a>
                                            <span class="btn btn-sm btn-danger mb-3"><i class="bi bi-trash"></i></span>
                                            {{-- <span class="badge bg-warning text-dark">View</span> --}}
                                        </td>
                                    </tr>
                                    @endforeach
                                </tbody>
                            </table>
                            <!-- End Table with stripped rows -->
                        </div>

                    </div>
                </div>

            </div>
        </div>
    </section>

</main><!-- End #main -->
@endsection

resources/views/adminview/documents/upload.blade.php
@extends('components.backend.layout')
@section('content')
<x-backend.header />
<x-backend.sidebar />

<main id="main" class="main">

    <x-backend.pagetitle title="Upload Document" />

    <section class="section">
        <div class="row">
            <div class="col-lg-12">

                <div class="card">
                    <div class="card-body py-5">

                        <!-- Floating Labels Form -->
                        <form class="row g-3" action="{{route('documents.store')}}" method="post"
                            enctype="multipart/form-data">
                            @csrf
                            <div class="col-md-12">
                                <div class="form-floating">
                                    <input type="text" class="form-control shadow-none" name="title" id="title" required
                                        placeholder="Title">
                                    <label for="title">Title <span>*</span> </label>
                                </div>
                            </div>

                            <div class="col-md-12">
                                <div class="form-floating">
                                    <input type="text" class="form-control shadow-none" name="slug" id="slug"
                                        placeholder="Slug" readonly>
                                    <label for="slug">Slug <span>*</span> </label>
                                </div>
                            </div>

                            <div class="col-md-6">
                                {{-- <div class="form-floating">
                                    <input type="file" class="form-control shadow-none" name="file" id="file"
                                        placeholder="File">

                                </div> --}}
                                <div class="form-floating">
                                    <input type="url" class="form-control shadow-none" name="link" id="link"
                                        placeholder="Link" required>

                                    <label for="link">OneDrive Link <span>*</span> </label>
                                </div>
                            </div>

                            <div class="col-md-6">
                                <div class="form-floating mb-3">
                                    <select class="form-select shadow-none" name="content_id" id="content_id"
                                        aria-label="Content">
                                        <option selected> -- Select--</option>
                                        @foreach ($contents as $content)
                                        <option value="{{$content->id}}">{{$content->name}}</option>

                                        @endforeach
                                    </select>
                                    <label for="content_id">Content <span>*</span> </label>
                                </div>
                            </div>

                            <div class="col-md-4">
                                <div class="form-floating">
                                    <button type="submit" class="btn btn-primary btn-get-started">Upload <i
                                            class="bi bi-upload"></i></button>
                                </div>
                            </div>

                        </form><!-- End floating Labels Form -->

                    </div>
                </div>

            </div>
        </div>
    </section>

</main><!-- End #main -->

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"
    integrity="sha512-3gJwYpMe3QewGELv8k/BX9vcqhryRdzRMxVfq6ngyWXwo03GFEzjsUm8Q7RZcHPHksttq7/GFoxjCVUjkjvPdw=="
    crossorigin="anonymous" referrerpolicy="no-referrer"></script>

<script>
    $(document).ready(function(){
    $('#title').change(function(e){
        $.get('{{ route("checkSlugDoc") }}',
            {'title':$(this).val(),},
            function (data){
                $('#slug').val(data.slug);
            }
        );
    });
    });

</script>
@endsection